﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr266_1
{
    // Обобщенный интерфейс с ограничением 
    // на обобщенный параметр: 
    interface MyInterface<T> 
        where T: struct{ void show(); }
    // Обобщенный класс реализует обобщенный интерфейс: 
    class MyClass<T>: MyInterface<T> 
        where T: struct {
        // Поле обобщенного типа: 
        public T val;
        // Конструктор: 
        public MyClass(T v) { 
            val = v;
        }
        // Описание метода из интерфейса: 
        public void show() {
            Console.WriteLine("Tип {0}: значение {1}", typeof(T).Name, val);
        }
    }

    // Главный класс: 
    class Program
    {
        static void Main()
        {
            // Создание объектов на основе обобщенного класса:
            MyClass<int> A = new MyClass<int>(100);
            MyClass<char> B = new MyClass<char>('B');
            // Вызов метода из объектов:
            A.show();
            B.show();
            // Задержка:
            Console.ReadLine();
        }
    }
}
